<div id="admin-shop-product">
  <div class="d-sm-flex align-center justify-space-between mx-1">
    <div id="hideBottomInput" class="d-sm-flex align-center">
      <div>
        <v-text-field
          dense
          outlined
          v-model="config.search"
          prepend-inner-icon="mdi-magnify"
          style="max-width: 320px; width: 100%"
          background-color="#ffffff"
          @keyup.enter="onGetListProduct()"
          placeholder="Search by name..."
        >
        </v-text-field>
      </div>
      <div class="d-flex h-10 mt-sm-0 mt-2">
        <div class="flex items-center px-2 mx-sm-2 mr-2 bg-white view-bt">
          <p class="mb-0">View:</p>
          <v-btn :color="checkGrid ? '' : 'blue'" icon @click="getListView()">
            <v-icon>mdi-view-grid-outline</v-icon>
          </v-btn>
          <v-btn :color="checkGrid ? 'blue' : ''" icon @click="getGridView()">
            <v-icon>mdi-view-list</v-icon>
          </v-btn>
        </div>
        <div class="">
          <nuxt-link to="/admin/products/create" class="text-decoration-none">
            <v-btn color="#076CE3" class="elevation-0" height="40px">
              <div class="d-flex align-center">
                <v-icon color="#ffffff"> mdi-plus </v-icon>
                <p class="mb-0 white--text fsize-15 ml-2 text-capitalize">
                  New product
                </p>
              </div>
            </v-btn>
          </nuxt-link>
        </div>
      </div>
    </div>
  </div>

  <v-card v-if="checkGrid == true" class="ui-card rounded-t-lg mt-4">
    <v-skeleton-loader
      class="mx-auto mt-10"
      width="100%"
      type="card"
      v-if="loadingTable"
    >
    </v-skeleton-loader>
    <v-simple-table
      class="scrollTable c-pointer"
      fixed-header
      v-else
      style="border: 1px solid #edeeef; border-radius: 8px 8px 8px 8px"
    >
      <template v-slot:default>
        <thead>
          <tr>
            <th class="px-0 table-head !rounded-tl-lg">
              <div
                class="d-flex align-center"
                style="width: 400px; height: 48px"
              >
                <p
                  class="mb-0 text-sm text-uppercase table-head ml-2 captionOverline !font-bold text-content-main"
                >
                  Product Name
                </p>
              </div>
            </th>
            <th class="text-left table-head">
              <div style="width: 100px">
                <p
                  class="mb-0 text-sm text-uppercase table-head captionOverline !font-bold text-content-main"
                >
                  Variants
                </p>
              </div>
            </th>
            <!-- <th class="text-left px-0 table-head">
              <div  style="width: 200px">
                <p
                  class="mb-0 text-sm text-uppercase table-head captionOverline !font-bold text-content-main"
                >
                  Collection
                </p>
              </div>
            </th> -->
            <th class="text-left px-0 table-head">
              <div style="width: 100px">
                <p
                  class="mb-0 text-sm text-uppercase table-head captionOverline !font-bold text-content-main"
                >
                  Price
                </p>
              </div>
            </th>
            <th class="text-left px-0 table-head">
              <div style="width: 150px">
                <p
                  class="mb-0 text-sm text-uppercase table-head captionOverline !font-bold text-content-main"
                >
                  Status
                </p>
              </div>
            </th>
            <th class="text-left px-0 table-head">
              <div style="width: 150px">
                <p
                  class="mb-0 text-sm text-uppercase table-head captionOverline !font-bold text-content-main"
                >
                  Created At
                </p>
              </div>
            </th>
            <th class="text-left px-0 table-head !rounded-tr-lg">
              <div style="width: 200px">
                <p
                  class="mb-0 text-sm text-uppercase table-head captionOverline !font-bold text-content-main"
                ></p>
              </div>
            </th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="(product,i) in listProduct" :key="product._id">
            <td class="py-2">
              <div class="d-flex align-center">
                <div style="width: 500px" class="d-flex align-center">
                  <nuxt-link
                    :to="`/admin/products/edit/${product._id}`"
                    class="text-decoration-none"
                  >
                    <div class="d-flex align-center">
                      <div
                        class="d-flex align-center"
                        style="
                          min-width: 64px;
                          max-width: 64px;
                          width: 100%;
                          height: 64px;
                        "
                      >
                        <img
                          :src="convertImage(product)"
                          alt=""
                          class="rounded-lg"
                          style="width: 100%; height: 100%"
                        />
                      </div>
                      <p
                        class="mb-0 fsize-13 text-uppercase colorGreyHeaderTable ml-2"
                      >
                        {{product.productName}}
                      </p>
                    </div>
                  </nuxt-link>
                </div>
                <v-btn
                  icon
                  small
                  color="blue"
                  class="ml-3"
                  v-clipboard:copy="`${linkProduct(product._id)}`"
                  v-clipboard:success="onCopySuccess"
                  v-clipboard:error="onCopyError"
                >
                  <v-icon size="18"> mdi-content-copy </v-icon>
                </v-btn>
              </div>
            </td>
            <td class="">
              <p class="mb-0 fsize-14-400 text">
                {{product.listVariant && product.listVariant.length &&
                $utils.formatCurrency(product.listVariant.length)}}
              </p>
            </td>
            <!-- <td class="px-0">
              <p class="mb-0 fsize-14 font-weight-bold lightContentBlue">
                {{product.categoryId && product.categoryId.name}}
              </p>
            </td> -->
            <td class="px-0">
              <p class="mb-0 fsize-16 font-weight-bold lightContentPrimary">
                ${{calcPrice(product) &&
                $utils.formatCurrency(calcPrice(product))}}
              </p>
            </td>
            <td class="px-0">
              <v-menu offset-y>
                <template v-slot:activator="{ on, attrs }">
                  <v-btn
                    v-bind="attrs"
                    v-on="on"
                    class="rounded-xl elevation-0"
                    style="background-color: rgb(219 234 254)"
                    v-if="product.productStatus === 1"
                  >
                    <div class="flex items-center">
                      <v-icon color="blue" size="18"> mdi-pencil-box </v-icon>
                      <span
                        class="ml-2 fsize-12 font-weight-medium text-blue-500 text-none mx-2"
                      >
                        Editing
                      </span>
                      <v-icon color="#7A8C96"> mdi-menu-down </v-icon>
                    </div>
                  </v-btn>
                  <v-btn
                    color="#ECFDF3"
                    v-bind="attrs"
                    v-on="on"
                    class="rounded-xl elevation-0"
                    v-if="product.productStatus === 2"
                  >
                    <div class="flex items-center">
                      <v-icon color="#12B76A" size="18">
                        mdi-package-variant-closed-check
                      </v-icon>
                      <span
                        class="ml-2 fsize-12 font-weight-medium text-none mx-2 text-green-500"
                      >
                        Publishing
                      </span>
                      <v-icon color="#7A8C96"> mdi-menu-down </v-icon>
                    </div>
                  </v-btn>
                  <v-btn
                    color="#FEF3F2"
                    v-bind="attrs"
                    v-on="on"
                    class="rounded-xl elevation-0"
                    v-if="product.productStatus === 3"
                  >
                    <div class="flex items-center">
                      <v-icon color="#F04438" size="18">
                        mdi-close-octagon
                      </v-icon>
                      <span
                        class="ml-2 fsize-12 font-weight-medium text-none mx-2 text-red-500"
                      >
                        Close
                      </span>
                      <v-icon color="#7A8C96"> mdi-menu-down </v-icon>
                    </div>
                  </v-btn>
                </template>
                <div class="py-2 white px-3">
                  <div class="py-3">
                    <v-btn
                      class="rounded-xl elevation-0"
                      block
                      @click="onChangeStatus(product, 1)"
                      style="background-color: rgb(219 234 254)"
                      :disabled="product.productStatus === 2 || product.productStatus === 3"
                    >
                      <div
                        class="flex items-center py-1 px-2 rounded-xl mx-3 cursor-pointer"
                      >
                        <v-icon color="blue"> mdi-pencil-box </v-icon>
                        <span
                          class="ml-2 fsize-12 font-weight-medium text-blue-500"
                        >
                          Editing
                        </span>
                      </div>
                    </v-btn>
                  </div>
                  <div class="py-3">
                    <v-btn
                      color="#ECFDF3"
                      class="rounded-xl elevation-0"
                      block
                      @click="onChangeStatus(product, 2)"
                      :disabled="product.productStatus === 3"
                    >
                      <div
                        class="flex items-center py-1 px-2 rounded-xl mx-3 cursor-pointer"
                      >
                        <v-icon color="#12B76A">
                          mdi-package-variant-closed-check
                        </v-icon>
                        <span
                          class="ml-2 fsize-12 font-weight-medium text-green-500"
                        >
                          Save
                        </span>
                      </div>
                    </v-btn>
                  </div>
                  <div class="py-3">
                    <v-btn
                      color="#FEF3F2"
                      class="rounded-xl elevation-0"
                      block
                      @click="onChangeStatus(product, 3)"
                      :disabled="product.productStatus === 2 || product.productStatus === 3"
                    >
                      <div
                        class="flex items-center py-1 px-2 rounded-xl mx-3 cursor-pointer"
                      >
                        <v-icon color="#F04438"> mdi-close-octagon </v-icon>
                        <span
                          class="ml-2 fsize-12 font-weight-medium text-red-500"
                        >
                          Close
                        </span>
                      </div>
                    </v-btn>
                  </div>
                </div>
              </v-menu>
            </td>
            <td class="px-0">
              {{product.createdAt && formatDate(product.createdAt)}}
            </td>
            <td class="px-0">
              <div class="d-flex align-center">
                <nuxt-link
                  :to="`/admin/products/edit/${product._id}`"
                  class="text-decoration-none"
                >
                  <v-btn color="#076CE3" class="mr-2 elevation-0">
                    <span class="text-white"> Edit </span>
                  </v-btn>
                </nuxt-link>
                <nuxt-link
                  :to="`/admin/products/duplicate/${product._id}`"
                  class="text-decoration-none"
                >
                  <v-btn color="#076CE3" outlined>
                    <span class="lightContentBlue"> Duplicate </span>
                  </v-btn>
                </nuxt-link>
                <!-- <v-btn color="#FF5252" outlined class="ml-2 px-0" style="min-width: 36px"
                  @click="openDialogDeleteProduct(product._id)">
                  <v-icon color="#FF5252">
                    mdi-delete
                  </v-icon>
                </v-btn> -->
              </div>
            </td>
          </tr>
        </tbody>
      </template>
    </v-simple-table>
    <div
      class="d-flex justify-center my-2"
      v-if="listProduct.length == 0 && !loadingTable"
    >
      <span>Before you open your store, first you need some products.</span>
    </div>
    <div class="text-center mt-4 pb-2 d-flex align-center justify-center">
      <v-pagination
        v-model="config.page"
        :length="totalPage"
        :total-visible="5"
        class="pagination"
      >
      </v-pagination>
      <div id="hideBottomInput" class="input-gotopage pos-relative">
        <v-text-field
          dense
          outlined
          v-model.number="page"
          placeholder="Go to page"
        >
        </v-text-field>
        <div class="button-inside-input">
          <v-btn
            height="36px"
            color="#076CE3"
            class="px-0 button-inside-input__button elevation-0"
            @click="onRedirectPage()"
          >
            <v-icon color="#ffffff"> mdi-chevron-right </v-icon>
          </v-btn>
        </div>
      </div>
    </div>
  </v-card>

  <div v-else>
    <v-skeleton-loader
      class="mx-auto mt-10"
      width="100%"
      type="card"
      v-if="loadingTable"
    >
    </v-skeleton-loader>
    <div v-else class="grid grid-cols-12 mt-4 sm:gap-4 gap-3">
      <div
        v-for="(item, idx) in listProduct"
        :key="idx"
        class="xl:col-span-2 lg:col-span-3 sm:col-span-4 col-span-6"
      >
        <nuxt-link :to="`/admin/products/edit/${item._id}`" target="_blank">
          <v-card
            class="elevation-0 bg-blue-100 h-full product-card d-flex flex-column justify-between p-2"
            style="border: 1px solid #e5e7eb !important"
          >
            <div class="img-fr">
              <img
                v-if="item.listImageId && item.listImageId[0] && item.listImageId[0].imageUrl"
                :src="convertImage(item || '')"
                alt=""
              />
              <img v-else src="~assets/images/no-product.png" alt="" />
            </div>

            <p class="font-normal text-sm sm:text-base text-desc my-3">
              {{item && item.productName && item.productName.length > 40 ?
              item.productName.slice(0,40) + '...': item.productName}}
            </p>

            <div class="flex justify-between gap-3 price-fr" style="">
              <div class="flex flex-col justify-center bg-gray-100 px-2">
                <p class="text-xs font-normal mb-0">Selling Price</p>
                <p class="font-semibold text-sm mb-0">
                  {{item && item.listVariant[0] && item.listVariant[0].price}}
                </p>
              </div>
              <div class="flex flex-col justify-center bg-gray-100 px-2">
                <p class="text-xs font-normal mb-0">
                  Cost
                  <span class="icon-cost">
                    <v-icon color="#171717" small>
                      mdi-help-circle-outline
                    </v-icon>
                  </span>
                </p>
                <p class="font-semibold text-sm mb-0">
                  {{item && item.listVariant[0] &&
                  item.listVariant[0].productCost}}
                </p>
              </div>
            </div>
          </v-card>
        </nuxt-link>
      </div>
    </div>
    <div class="text-center mt-4 pb-2 d-flex align-center justify-center">
      <v-pagination
        v-model="config.page"
        :length="totalPage"
        :total-visible="5"
        class="pagination"
      >
      </v-pagination>
      <div id="hideBottomInput" class="input-gotopage pos-relative">
        <v-text-field
          dense
          outlined
          v-model.number="page"
          placeholder="Go to page"
        >
        </v-text-field>
        <div class="button-inside-input">
          <v-btn
            height="36px"
            color="#076CE3"
            class="px-0 button-inside-input__button elevation-0"
            @click="onRedirectPage()"
          >
            <v-icon color="#ffffff"> mdi-chevron-right </v-icon>
          </v-btn>
        </div>
      </div>
    </div>
  </div>

  <v-row justify="center">
    <v-dialog v-model="dialogDeleteProduct" max-width="383">
      <v-card class="pa-0">
        <div class="py-5 px-6">
          <div class="d-flex align-center justify-center">
            <v-icon color="#EB5757" size="56"> mdi-delete-forever </v-icon>
          </div>
          <p class="mb-0 mt-4 h6 text-center contentSemanticRed">
            Delete Product
          </p>
          <p class="mt-6 fsize-16 contentMain">
            Do you want to delete this product {{findNameProduct}}?
          </p>
        </div>
        <div class="pb-8 px-4 d-flex align-center justify-space-between">
          <v-btn
            text
            width="49%"
            @click="dialogDeleteProduct = false"
            :disabled="loading"
          >
            <p class="mb-0 fsize-16 font-weight-bold lightContentPrimary">
              Cancel
            </p>
          </v-btn>
          <v-btn
            color="#FF5252"
            class="elevation-0"
            width="49%"
            @click="onDeleteProduct()"
            :disabled="loading"
          >
            <v-progress-circular
              indeterminate
              color="#FF5252"
              v-if="loading"
              size="22"
            >
            </v-progress-circular>
            <p class="mb-0 fsize-16 font-weight-bold white--text" v-else>
              Delete
            </p>
          </v-btn>
        </div>
      </v-card>
    </v-dialog>
  </v-row>

  <v-row justify="center">
    <v-dialog v-model="dialogDeleteMultipleProduct" max-width="383">
      <v-card class="pa-0">
        <div class="py-5 px-6">
          <div class="d-flex align-center justify-center">
            <v-icon color="#EB5757" size="56"> mdi-delete-forever </v-icon>
          </div>
          <p class="mb-0 mt-4 h6 text-center contentSemanticRed">
            Delete product
          </p>
          <p class="mt-6 fsize-16 contentMain">
            Do you want to delete {{listIds.length}} product?
          </p>
        </div>
        <div class="pb-8 px-4 d-flex align-center justify-space-between">
          <v-btn
            text
            width="49%"
            @click="dialogDeleteMultipleProduct = false"
            :disabled="loading"
          >
            <p class="mb-0 fsize-16 font-weight-bold lightContentPrimary">
              Cancel
            </p>
          </v-btn>
          <v-btn
            color="#FF5252"
            class="elevation-0"
            width="49%"
            @click="onDeleteMultipleProduct()"
            :disabled="loading"
          >
            <v-progress-circular
              indeterminate
              color="#FF5252"
              v-if="loading"
              size="22"
            >
            </v-progress-circular>
            <p class="mb-0 fsize-16 font-weight-bold white--text" v-else>
              Delete
            </p>
          </v-btn>
        </div>
      </v-card>
    </v-dialog>
  </v-row>
</div>
